<?php
// +-----------------------------------------------------------------------+
// | DotClear Easy - a PWG Plugin
// | Copyright (C) 2007 Ruben ARNAUD - rub@phpwebgallery.net               |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

class DotclearEasy
{
  var $plugin_name, $plugin_path;
  var $opened, $to_close;
  
  function DotclearEasy($plugin_name, $plugin_path)
  {
    // Args
    $this->plugin_name = $plugin_name;
    $this->plugin_path = $plugin_path;
    // handler
    $this->initialize_event_handler();
  }

  function initialize_event_handler()
  {
    if (script_basename() != $this->plugin_name.'_controller')
    {
      add_event_handler('loc_end_page_header', array(&$this, 'loc_end_page_header'));
      add_event_handler('loc_end_index', array(&$this, 'loc_end_index'));
      add_event_handler('picture_pictures_data', array(&$this, 'picture_pictures_data'));
    }

    if (isset($_GET[$this->plugin_name]))
    {
      add_event_handler('loc_begin_page_header', array(&$this, 'loc_begin_page_header'));
      pwg_set_session_var($this->plugin_name, ($_GET[$this->plugin_name] === 'open'));
    }
    $this->opened = pwg_get_session_var($this->plugin_name, false);
    $this->to_close = (isset($_GET[$this->plugin_name]) and ($_GET[$this->plugin_name] === 'close'));
  }

  function get_text_dotclear()
  {
    global $page, $lang_info;

    $list = array();
  
    $S = '';

    switch (script_basename())
    {
      case 'index':
      {
        global $pictures;

        if (isset($pictures))
        {
          $list = $pictures;
        }
        break;
      }
      case 'picture':
      {
        global $picture;

        if (isset($picture['current']))
        {
          $list[] = $picture['current'];
        }
        break;
      }
    }

    if (empty($list) and !empty($page['items']))
    {
      $query = '
  SELECT *
    FROM '.IMAGES_TABLE.'
    WHERE id IN ('.implode(',', $page['items']).')
  ;';

      $result = pwg_query($query);

      while ($row = mysql_fetch_assoc($result))
      {
        $row['rank'] = $page['rank_of'][ $row['id'] ];
        array_push($list, $row);
      }

      usort($list, 'rank_compare');
  }

    if (!empty($list))
    {
      set_make_full_url();

      foreach ($list as $row)
      {
       //'[(('.$picture['current']['thumbnail'].'))|'.$picture['current']['url'].'|'.$lang_info['code'].']';
        $S  .= ' '.(!empty($row['name']) ? $row['name'] : $row['file']).' \n';
        $S  .= '[(('.
          str_replace('/./', '/', get_thumbnail_url($row)).'))|'.
          duplicate_picture_url(
            array(
              'image_id' => $row['id'],
              'image_file' => $row['file'],
              )).'|'.
          $lang_info['code'].']\n\n';
      }

      unset_make_full_url();
    }

    return $S;
  }

  function loc_begin_page_header()
  {
    global $template;

    $redirect_url = ( script_basename()=='picture'
        ? duplicate_picture_url(array(), array($this->plugin_name))
          : duplicate_index_url(array(), array($this->plugin_name))
      );

    $template->assign_vars(
      array(
        'U_REDIRECT_MSG' => 'toto',
        'REFRESH_TIME' => 1,
        'U_REFRESH' => $redirect_url
        ));
    $template->assign_block_vars('refresh', array());
  }

  function loc_end_page_header()
  {
    global $template;

    if ($this->opened or $this->to_close)
    {
      $plugin_root_url = get_root_url().'plugins/'.$this->plugin_name.'/';

      $js = '
  <script type="text/javascript">
    var theController = window.open("", "'.$this->plugin_name.'_controller", "alwaysRaised=yes,dependent=yes,toolbar=no,height=570,width=500,menubar=no,resizable=yes,scrollbars=yes,status=no");';

    if ($this->to_close)
    {
      $js .= '
    theController.close();';
    }
    else
    {
      $js .= '
    if (theController.location.toString()=="about:blank" || !theController.location.toString().match(/^(https?.*\/)'.$this->plugin_name.'_controller\.php(\?.+)?$/))
    {
      theController.location = "'.$plugin_root_url.$this->plugin_name.'_controller.php";
    }
    else
    {
      theController.focus();
    }
    theController.document.getElementsByName("content_text")[0].value = "'.$this->get_text_dotclear().'";';
    }
      $js .= '
  </script>';

      $template->assign_block_vars('head_element', array(
        'CONTENT' => $js
          )
        );
    }
  }

  function get_link_icon($main_link)
  {
    global $page;

    if (empty($page['items']))
    {
        return;
    }

    $this->loading_lang();

    if ($this->opened)
    {
      $suffix_url = 'close';
      $link_title = l10n('close_window_dotclear_easy');
    }
    else
    {
      $suffix_url = 'open';
      $link_title = l10n('open_window_dotclear_easy');
    }

    $link_url = add_url_params($main_link, array($this->plugin_name => $suffix_url));
    if (!empty($link_url))
    {
      $link_url = 
        '<a href="'.$link_url.'" title="'.$link_title.'" rel="nofollow"><img src="'.get_root_url().'plugins/'.$this->plugin_name.'/icon/controller_'.$suffix_url.'.png" class="button" alt="DotClear Easy controller"></a>';
    }

    return $link_url;
  }

  function loc_end_index()
  {
    global $template;

    $link_url = $this->get_link_icon(duplicate_index_url());
    if (!empty($link_url))
    {
      $template->concat_var(
        'PLUGIN_INDEX_ACTIONS',
        '<li>'.$link_url.'</li>');
    }
  }

  function picture_pictures_data($pictures)
  {
    global $template;

    $link_url = $this->get_link_icon(duplicate_picture_url());
    if (!empty($link_url))
    {
      $template->concat_var(
        'PLUGIN_PICTURE_ACTIONS',
        $link_url);
    }

    return $pictures;
  }

  function loading_lang()
  {
    global $lang;

    include(get_language_filepath('plugin.lang.php', $this->plugin_path));
  }
}

?>
